#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define pb push_back
#define fi first
#define se second
#define en '\n'
#define sp ' '
#define tb '\t'
#define ri(n) int n; cin >> n
#define rl(n) ll n; cin >> n
#define rs(s) string s; cin >> s
#define rc(c) char c; cin >> c
#define rv(v) for (auto &x : v) cin >> x
#define pven(v) for (auto x : v) cout << x << en
#define pv(v) for (auto x : v) cout << x << sp; cout << en
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define yes cout << "YES" << en
#define no cout << "NO" << en
#define smin(a, b) a = min(a, b)
#define smax(a, b) a = max(a, b)
#define ssort(a, b) if (a < b) swap(a, b)
#define bitcnt(a) (__builtin_popcountll(a))
#define bithigh(a) (63-__builtin_clzll(a))
#define lg bithigh
#define highpow(a) (1LL << (ll)lg(a))

using namespace std;

const ll LINF = 4e18;
const int mxN = 1e6+10, INF = 2e9;
ll n, m, a[mxN];
map<int, int> cnt;

int BS(int x){

    int l = 0, r = n-1, ans = n;
    while (l <= r){
        int k = (l + r + 1)>>1;
        if (a[k] >= x){
            r = k - 1;
            ans = k;
        }
        else l = k + 1;
    }
    return ans;
}

int Calc(int cnt0, int cnt1){

    int l = 0, r = 2*n-1, ans = 2*n;
    while (l <= r){
        int k = (l + r + 1)>>1;
        if (cnt0 <= (n+k)/2 && cnt0 + cnt1 + k > n/2){
            r = k - 1;
            ans = k;
        }
        else l = k + 1;
    }
    return ans;
}

void Solve(){

    cin >> n >> m;
    for (int i = 0; i < n; i++){
        cin >> a[i];
        cnt[a[i]]++;
    }
    sort(a, a+n);
    while (m--){
        ri(x);
        int i = BS(x);
        cout << Calc(i, cnt[x]) << en;
    }
}

int main(){

    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0); cerr.tie(0);
    cout << setprecision(12) << fixed;
    cerr << setprecision(12) << fixed;
    cerr << "Started!" << endl;

    int t = 1;
    //cin >> t;
    while (t--)
        Solve();

    return 0;
}